<template>
    <div class="app-container">
        <GmapMap 
            id="map"
            ref="mapRef"
            :options="{
                zoomControl: true,
                mapTypeControl: false,
                scaleControl: false,
                streetViewControl: false,
                rotateControl: false,
                fullscreenControl: true,
                disableDefaultUi: false
            }"
            :zoom="map.zoom"
            :center="map.center">
            <GmapMarker
                :key="index"
                v-for="(marker, index) in markers"
                :position="marker.position"
                :clickable="true"
                :draggable="false"
                @click="handleRightPanel(marker, index)"
            />
        </GmapMap>
        <div class="right-panel-container" v-bind:class="{ show: showRightPanel}">
            <div class="right-panel-background" @click="showRightPanel = false"></div>
            <div class="right-panel">
                <h1 style="padding:20px;margin:0;border-bottom:1px dashed #eee;">{{ panel.panic }}</h1>
                <h3 style="padding:0 20px;">{{ panel.reporter.fullname }}</h3>
                <span class="display-block" style="padding:0 20px;font-size:14px;margin:10px 0;">{{ panel.reporter.address }}</span>
                <span class="display-block" style="padding:0 20px;font-size:14px;">+{{ panel.reporter.phone }}</span>

                <h3 style="padding:20px 20px 0 ;border-top: 1px dashed #eee;">CCTV Perumahan</h3>
                <ul v-loading="rightPanelLoading" v-if="cctvs.length > 0" class="cctv">
                    <li v-for="cctv in cctvs" v-bind:key="cctv.id">
                        <a href="#">
                            <span>{{ cctv.name }}</span>
                            <small>Jarak: {{ distance(cctv.latitude, cctv.longitude, panel.reporter.latitude, panel.reporter.longitude) }}</small>
                        </a>
                    </li>
                </ul>
                <ul v-loading="rightPanelLoading" v-else class="cctv">
                    <li>
                        <a href="#">Tidak ada CCTV</a>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</template>
<script>
import {gmapApi} from 'vue2-google-maps';
import Pusher from 'pusher-js';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, distance} from '@/utils/index';
import { setTimeout } from 'timers';
export default {
    name: 'Dashboard',
    data() {
        return {
            rightPanelLoading: false,
            showRightPanel: false,
            map: {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                }                
            },
            markers: [],
            panel: {
                panic: '',
                reporter:{
                    id: null,
                    name: '',
                    address: '',
                    phone: '',
                    latitude: null,
                    longitude: null,
                    residential_id: null
                }
            },
            reporters: []
        }
    },
    computed: {
        ...mapGetters('auth', ['token', 'user']),
        ...mapGetters('cctv', ['cctvs']),
        ...mapGetters('panicreport', [
            'panicreports',
            'pagination'
        ]),
    },
    watch: {
        markers(markers) {
            if (markers.length > 1) {
                const bounds = new google.maps.LatLngBounds();
                for (let m of markers) {
                    bounds.extend(m.position);
                }
                this.$refs.mapRef.fitBounds(bounds);
            }else{
                this.map.center.lat = markers[0].position.lat;
                this.map.center.lng = markers[0].position.lng;
            }
        }
    },
    created() {

        const self = this;

        Pusher.logToConsole = true;

        var pusher = new Pusher('84d7991410678a0998f6', {
            cluster: 'ap1',
            forceTLS: true
        });

        var panic_channel = pusher.subscribe('panic');
        
        panic_channel.bind('alarm', function(data) {

            if(data && data.hasOwnProperty('nid') == false && data.reporter.residential_id == self.user.residential.id && self.reporters.indexOf(data.reporter.id) == -1){
                self.markers.push({
                    position: {
                        lat: parseFloat(data.reporter.latitude),
                        lng: parseFloat(data.reporter.longitude)
                    },
                    reporter: data.reporter,
                    panic: data.panic
                });

                let sound = require('../../assets/sounds/alarm-buzzer.mp3');
                let audio = new Audio(sound);

                setTimeout(()=>{
                    self.playAlarm(audio);                    
                }, 1000);

                self.$alert('<h3>' + data.reporter.fullname.toUpperCase() + '</h3><span style="display:block;">'+data.reporter.address+'</span><strong style="display:block;">No. Handphone: '+data.reporter.phone+'</strong>', data.panic.toUpperCase(), {
                    confirmButtonText: 'OK',
                    dangerouslyUseHTMLString: true,
                    callback: action => {
                        self.stopAlarm(audio);
                    }
                });

                self.getCCTVS(data.reporter.residential_id);
                self.reporters.push(data.reporter.id);
            }            
        });
    },
    methods: {
        playSound,
        google: gmapApi,
        distance,
        playAlarm(audio){
            if(typeof audio.loop == 'boolean'){
                audio.loop = true;
            }else{
                audio.addEventListener('ended', function(){
                    this.currentTime = 0;
                    this.play();
                }, false);
            }

            let audioPlay = audio.play();

            if(audioPlay !== null){
                audioPlay.catch(()=>{
                    audio.play();
                });
            }
        },
        stopAlarm(audio){
            audio.pause();
        },
        handleRightPanel(marker, index){
            const self = this;

            self.panel.panic = marker.panic;
            self.panel.reporter.id = marker.reporter.id;
            self.panel.reporter.fullname = marker.reporter.fullname;
            self.panel.reporter.address = marker.reporter.address;
            self.panel.reporter.phone = marker.reporter.phone;
            self.panel.reporter.latitude = parseFloat(marker.reporter.latitude);
            self.panel.reporter.longitude = parseFloat(marker.reporter.longitude);
            self.panel.reporter.residential_id = marker.reporter.residential_id;

            self.showRightPanel = true;
        },
        getCCTVS(residential_id){
            const self = this;

            self.rightPanelLoading = true;

            self.$store.dispatch('cctv/getCCTVs', {
                residential: residential_id
            }).then(()=>{
                self.rightPanelLoading = false;
            });
        },
    }
}
</script>
<style>
    #map{
        width: 100%;
        height: calc(100vh - 150px);
    }
    .show{
        -webkit-transition: all .3s cubic-bezier(.7,.3,.1,1);
        transition: all .3s cubic-bezier(.7,.3,.1,1);
    }

    .right-panel-background{
        position: absolute;
        top: 0;
        left: 0;
        opacity: 0;
        -webkit-transition: opacity .3s cubic-bezier(.7,.3,.1,1);
        transition: opacity .3s cubic-bezier(.7,.3,.1,1);
        background: rgba(0,0,0,.2);
        z-index: -1;
    }

    .show .right-panel-background{
        z-index: 20000;
        opacity: 1;
        width: 100%;
        height: calc(100% - 80px);
    }

    .right-panel{
        width: 100%;
        max-width: 260px;
        height: calc(100% - 80px);
        position: absolute;
        top: 0;
        right: 0px;
        -webkit-box-shadow: 0 0 15px 0 rgba(0,0,0,.05);
        box-shadow: 0 0 15px 0 rgba(0,0,0,.05);
        -webkit-transition: all .25s cubic-bezier(.7,.3,.1,1);
        transition: all .25s cubic-bezier(.7,.3,.1,1);
        -webkit-transform: translate(100%);
        transform: translate(100%);
        background: #fff;
        z-index: 40000;
        padding: 0;
    }

    .show .right-panel{
        right: 260px;
    }

    ul.cctv{
        padding: 0;
        list-style: none;
    }

    ul.cctv > li{
        padding: 0;
        margin-bottom: 10px;
        border-top: 1px dashed #eee;
    }

    ul.cctv > li a{
        padding: 10px 20px;
        display: block;
    }

    ul.cctv > li a span{
        display: block;
        font-size: 14px;
        margin-bottom: 5px;
    }

    ul.cctv > li a small{
        display: block;
        font-size: 12px;
    }
</style>